/* history_box.h -- dynamic directory input box with history.
 *
 * Copyright (C) 1999 Steve Hill <sjhill@plutonium.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __HISTORY_BOX_H__
#define __HISTORY_BOX_H__

#ifdef __cplusplus
extern "C"
{
#endif				/* __cplusplus */

/* Creates the history box. */
  GtkWidget *history_box_new (void);

/* Creates the history box using a list to initialize
 * the history.
 */
  GtkWidget *history_box_new_with_history (GList * list);

/* Destroys the history box. */
  void history_box_destroy (void);

/* Clears the history list. */
  void history_box_clear_history (void);

/* Gets the current history list. */
  GList *history_box_get_history (void);

#ifdef __cplusplus
}
#endif				/* __cplusplus */

#endif				/* __HISTORY_BOX_H__ */
