/* mount_list.h -- maintains the list of mounted filesystems. Large portions
 *                 of this module borrowed from Midnight Commander.
 *              
 * Copyright (C) 1999 Steve Hill <sjhill@plutonium.net> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __MOUNT_LIST_H_
#define __MOUNT_LIST_H_

/* A mount table entry. */
struct mount_entry
  {
    gchar *devname;		/* Device node pathname. */
    gchar *mountpoint;		/* Mount point pathname. */
    gchar *type;		/* "nfs", "ext2", etc. */
    gchar *options;		/* "ro", "rw", etc. */
    struct mount_entry *next;	/* Next filesystem in the list. */
  };

/* Builds the mounted filesystem list for use by GVFS and friends.
 * Returns number of file systems currently mounted not including
 * "/proc" if present.
 */
guint build_mount_list (void);

/* Returns pointer to the mounted filesystem list. */
struct mount_entry *get_mount_list (void);

#endif /* __MOUNT_LIST_H_ */
